diff -pruN 2.4.2-2/debian/changelog 2.4.2-2.3/debian/changelog
--- 2.4.2-2/debian/changelog	2013-03-23 12:51:28.000000000 +0000
+++ 2.4.2-2.3/debian/changelog	2020-05-05 14:12:20.000000000 +0000
@@ -1,3 +1,26 @@
+cpufreqd (2.4.2-2.3) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * Fix build on power : call to libcpupower *available_frequencies
+    functions can be made directly since kernel 5.6.7 (Closes: #958798).
+
+ -- Frédéric Bonnard <frediz@debian.org>  Tue, 05 May 2020 16:12:20 +0200
+
+cpufreqd (2.4.2-2.2) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * Fix build on power* since linux 5.1 introduced backward incompatilities in
+    libcpupower (Closes: #935692)
+
+ -- Frédéric Bonnard <frediz@debian.org>  Thu, 29 Aug 2019 12:30:53 +0200
+
+cpufreqd (2.4.2-2.1) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * Fix build on ppc64el by using libcpupower (Closes: #921099).
+
+ -- Frédéric Bonnard <frediz@debian.org>  Thu, 09 May 2019 18:40:03 +0200
+
 cpufreqd (2.4.2-2) unstable; urgency=low
 
   * Fix reading the correct battery attribute
diff -pruN 2.4.2-2/debian/control 2.4.2-2.3/debian/control
--- 2.4.2-2/debian/control	2013-03-23 12:51:28.000000000 +0000
+++ 2.4.2-2.3/debian/control	2020-05-05 14:12:20.000000000 +0000
@@ -2,7 +2,7 @@ Source: cpufreqd
 Section: admin
 Priority: optional
 Maintainer: Mattia Dongili <malattia@debian.org>
-Build-Depends: debhelper (>= 7), quilt, automake, libtool, libsensors4-dev, libcpufreq-dev, libsysfs-dev (>= 2.0.0)
+Build-Depends: debhelper (>= 7), quilt, automake, libtool, libsensors4-dev, libcpufreq-dev [!powerpc !ppc64 !ppc64el], libcpupower-dev[powerpc ppc64 ppc64el], libsysfs-dev (>= 2.0.0)
 Standards-Version: 3.8.4
 Homepage: http://sourceforge.net/projects/cpufreqd
 
diff -pruN 2.4.2-2/debian/patches/fix-build-on-power-since-kernel-5.6.7.patch 2.4.2-2.3/debian/patches/fix-build-on-power-since-kernel-5.6.7.patch
--- 2.4.2-2/debian/patches/fix-build-on-power-since-kernel-5.6.7.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.4.2-2.3/debian/patches/fix-build-on-power-since-kernel-5.6.7.patch	2020-05-05 14:12:20.000000000 +0000
@@ -0,0 +1,24 @@
+From: Frédéric Bonnard <frediz@debian.org>
+Date: Tue, 5 May 2020 16:05:50 +0200
+X-Dgit-Generated: 2.4.2-2.3 d7f737e5c3f685cc8182fe3aec1e9043bf1befd9
+Subject: Fix build on power since kernel 5.6.7
+
+No need for the wrappers anymore
+
+---
+
+--- cpufreqd-2.4.2.orig/src/cpufreqd.h
++++ cpufreqd-2.4.2/src/cpufreqd.h
+@@ -59,10 +59,12 @@
+ #ifdef __powerpc__
+ #include <linux/version.h>
+ #if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 1, 0)
++#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 6, 7)
+ #define cpufreq_available_frequencies cpufreq_frequencies
+ #define cpufreq_get_available_frequencies(cpu) cpufreq_get_frequencies ("available", cpu)
+ #define cpufreq_put_available_frequencies(first) cpufreq_put_frequencies (first)
+ #endif
+ #endif
++#endif
+ 
+ #endif /* __CPUFREQD_H__ */
diff -pruN 2.4.2-2/debian/patches/fix-build-on-power-with-libcpupower-from.patch 2.4.2-2.3/debian/patches/fix-build-on-power-with-libcpupower-from.patch
--- 2.4.2-2/debian/patches/fix-build-on-power-with-libcpupower-from.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.4.2-2.3/debian/patches/fix-build-on-power-with-libcpupower-from.patch	2020-05-05 14:12:20.000000000 +0000
@@ -0,0 +1,24 @@
+From: Frédéric Bonnard <frediz@debian.org>
+Date: Wed, 28 Aug 2019 17:45:49 +0200
+X-Dgit-Generated: 2.4.2-2.2 84d796100f73786633f76cff34ce19c22354d8bf
+Subject: Fix build on power* with libcpupower from kernel >= 5.1
+
+
+---
+
+--- cpufreqd-2.4.2.orig/src/cpufreqd.h
++++ cpufreqd-2.4.2/src/cpufreqd.h
+@@ -56,4 +56,13 @@
+ #define MAX_STRING_LEN		255
+ #define MAX_PATH_LEN		512
+ 
++#ifdef __powerpc__
++#include <linux/version.h>
++#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 1, 0)
++#define cpufreq_available_frequencies cpufreq_frequencies
++#define cpufreq_get_available_frequencies(cpu) cpufreq_get_frequencies ("available", cpu)
++#define cpufreq_put_available_frequencies(first) cpufreq_put_frequencies (first)
++#endif
++#endif
++
+ #endif /* __CPUFREQD_H__ */
diff -pruN 2.4.2-2/debian/patches/ppc64el.patch 2.4.2-2.3/debian/patches/ppc64el.patch
--- 2.4.2-2/debian/patches/ppc64el.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.4.2-2.3/debian/patches/ppc64el.patch	2020-05-05 14:12:20.000000000 +0000
@@ -0,0 +1,55 @@
+Description: <short summary of the patch>
+ TODO: Put a short summary on the line above and replace this paragraph
+ with a longer explanation of this change. Complete the meta-information
+ with other relevant fields (see below for details). To make it easier, the
+ information below has been extracted from the changelog. Adjust it or drop
+ it.
+ .
+ cpufreqd (2.4.2-2) unstable; urgency=low
+ .
+   * Fix reading the correct battery attribute
+     (Closes: #619913 and Closes: #644567).
+Author: Mattia Dongili <malattia@debian.org>
+Bug-Debian: https://bugs.debian.org/619913
+Bug-Debian: https://bugs.debian.org/644567
+
+---
+The information above should follow the Patch Tagging Guidelines, please
+checkout http://dep.debian.net/deps/dep3/ to learn about the format. Here
+are templates for supplementary fields that you might want to add:
+
+Origin: <vendor|upstream|other>, <url of original patch>
+Bug: <url in upstream bugtracker>
+Bug-Debian: https://bugs.debian.org/<bugnumber>
+Bug-Ubuntu: https://launchpad.net/bugs/<bugnumber>
+Forwarded: <no|not-needed|url proving that it has been forwarded>
+Reviewed-By: <name and email of someone who approved the patch>
+Last-Update: 2019-05-09
+
+Index: cpufreqd-2.4.2/configure.in
+===================================================================
+--- cpufreqd-2.4.2.orig/configure.in
++++ cpufreqd-2.4.2/configure.in
+@@ -38,9 +38,21 @@ AC_CHECK_FUNCS([memset realpath strerror
+ AC_CHECK_LIB([dl], [dlopen],
+ 		[ CPUFREQD_LDFLAGS="${CPUFREQD_LDFLAGS} -ldl" ],
+ 		[ AC_MSG_ERROR([You need a working dlopen to build cpufreqd]) ])
++
++AC_CANONICAL_TARGET
++case "${target_cpu}" in
++  powerpc*)
++AC_CHECK_LIB([cpupower], [cpufreq_get_freq_kernel],
++		[ CPUFREQD_LDFLAGS="${CPUFREQD_LDFLAGS} -lcpupower" ],
++		[ AC_MSG_ERROR([You need libcpupower from linux to build cpufreqd]) ])
++      ;;
++  *)
+ AC_CHECK_LIB([cpufreq], [cpufreq_cpu_exists],
+-		[ CPUFREQD_LDFLAGS="${CPUFREQD_LDFLAGS} -lcpufreq" ],
++                [ CPUFREQD_LDFLAGS="${CPUFREQD_LDFLAGS} -lcpufreq" ],
+ 		[ AC_MSG_ERROR([You need libcpufreq from cpufrequtils to build cpufreqd]) ])
++      ;;
++esac
++
+ AC_SUBST(CPUFREQD_LDFLAGS)
+ 
+ DISABLED_PLUGINS=""
diff -pruN 2.4.2-2/debian/patches/series 2.4.2-2.3/debian/patches/series
--- 2.4.2-2/debian/patches/series	2013-03-23 12:51:28.000000000 +0000
+++ 2.4.2-2.3/debian/patches/series	2020-05-05 14:12:20.000000000 +0000
@@ -1 +1,4 @@
 619913.patch
+ppc64el.patch
+fix-build-on-power-with-libcpupower-from.patch
+fix-build-on-power-since-kernel-5.6.7.patch
